%undefine _auto_set_build_flags
%define debug_package %{nil}

Summary: Development Libraries and headers for EFI
Name: gnu-efi
Version: 3.0.11
Release: 4%{?dist}
License: BSD 
URL: https://sourceforge.net/projects/gnu-efi/
Source0:   %{url}files/gnu-efi-%{version}.tar.bz2

Patch3000: 0004-efilink-fix-build-with-gcc-4.8.patch
Patch3001: 0012-Revert-efilink-fix-build-with-gcc-4.8.patch
Patch3002: 0014-efibind-Fix-usage-of-efi-headers-from-C-code.patch
Patch3003: 0015-Fix-ARCH-on-ARMv6.patch
Patch3004: 0016-Re-add-back-the-original-symbol-typeo.patch
Patch3005: 0017-Add-elf.h-for-cross-building-without-a-system-libelf.patch
Patch3006: 0018-make-parameter-to-compile-apps-add-example-output-di.patch
Patch3007: 0019-Support-for-building-on-macOS-systems.patch
Patch3008: 0020-Make-apps-link-against-the-local-gnuefi-and-crt-obje.patch
Patch3009: 0021-Add-.travis.yml.patch
Patch3010: 0022-Use-EFI-canonical-names-everywhere-the-compiler-does.patch
Patch3011: 0023-Fix-a-minor-coverity-complaint-in-some-apps.patch
Patch3012: 0024-Add-stuff-that-s-got-weird-characters-to-.gitattribu.patch
Patch3013: 0025-Get-rid-of-some-unused-junk-that-has-the-BSD-4-claus.patch
Patch3014: 0026-Get-rid-of-unused-make-like-files-from-yore.patch
Patch3015: 0027-Make-ELF-constructors-and-destructors-work.patch
Patch3016: 0028-Remove-the-accidental-lib-Makefile.orig.patch
Patch3017: 0029-gitignore-add-our-build-directories.patch
Patch3018: 0030-make-Fix-shell-exit-status-handling.patch
Patch3019: 0031-make-Make-make-clean-use-and-rm-v-everywhere.patch
Patch3020: 0032-Make-our-dummy-.reloc-sections-not-depend-on-section.patch
Patch3021: 0033-Make-CHAR8-and-similar-be-defined-the-same-way-edk2-.patch
Patch3022: 0034-Make-make-TOPDIR-actually-work-and-get-rid-of-unused.patch
Patch3023: 0035-Make-make-make-DESTDIR-.-foo-install-work-right.patch
Patch3024: 0036-Install-our-libraries-in-LIBDIR-gnuefi-ARCH.patch
Patch3025: 0037-Install-all-headers-for-all-arches.patch
Patch3026: 0038-Rename-our-installed-.o-and-linker-scripts.patch
Patch3027: 0039-Supply-makefile-templates.patch
Patch3028: 0040-Semi-asciibetize-_Print-s-formatters.patch
Patch3029: 0041-Implement-Print-L-p-ptr.patch
Patch3030: 0042-Switch-to-fPIE.patch
Patch3031: 0043-lfbgrid-Make-pointer-size-testing-not-arch-name-depe.patch
Patch3032: 0044-Fix-the-arch-subdirs-in-.gitignore.patch
Patch3033: 0045-Use-CFLAGS-with-gcc-print-libgcc-file-name-to-get-th.patch
Patch3034: 0046-CFLAGS-add-Wno-pointer-sign.patch

BuildRequires: binutils efi-srpm-macros gcc git-core make

%description
This package contains development headers and libraries for developing applications
that run under EFI (Extensible Firmware Interface).

%package devel
Summary: Development Libraries and headers for EFI
Requires: gnu-efi = %{version}-%{release}
Requires: gnu-efi-compat = %{version}-%{release}
BuildArch: noarch

%description devel
This package contains development headers and libraries for developing applications
that run under EFI (Extensible Firmware Interface).

%package compat
Summary: Development Libraries and headers for EFI

%description compat
This package provides compatibility for building software utilizing gnu-efi which expects
the directory layout from older versions.

%package utils
Summary: Utilities for EFI systems

%description utils
This package contains utilities for debugging and developing EFI systems.

%prep
%autosetup -n gnu-efi-%{version} -p1 -Sgit

%build
make LIBDIR=%{_prefix}/lib
make apps
%if %{efi_has_alt_arch}
  setarch linux32 -B make ARCH=%{efi_alt_arch} PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib
  setarch linux32 -B make ARCH=%{efi_alt_arch} PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib apps
%endif

%install
make PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib INSTALLROOT=%{buildroot} install

mkdir -p %{buildroot}/%{efi_esp_dir}/%{efi_arch}
mv %{efi_arch}/apps/{route80h.efi,modelist.efi} %{buildroot}%{efi_esp_dir}/%{efi_arch}/

make PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib INSTALLROOT=%{buildroot} install_compat
mkdir -p %{buildroot}/%{_libdir}/gnuefi/
if [[ -d %{buildroot}/%{_prefix}/lib/gnuefi/x64 ]] ; then
  ln -s ../../lib/gnuefi/%{efi_arch} %{buildroot}/%{_libdir}/gnuefi/%{efi_arch}
  ln -s %{efi_arch}/crt0.o %{buildroot}/%{_libdir}/gnuefi/crt0-efi-x64.o
  ln -s %{efi_arch}/efi.lds %{buildroot}/%{_libdir}/gnuefi/elf_x64_efi.lds
  ln -s %{efi_arch}/crt0.o %{buildroot}/%{_libdir}/gnuefi/crt0-efi-x86_64.o
  ln -s %{efi_arch}/efi.lds %{buildroot}/%{_libdir}/gnuefi/elf_x86_64_efi.lds
  ln -s %{efi_arch}/libefi.a %{buildroot}/%{_libdir}/gnuefi/libefi.a
  ln -s %{efi_arch}/libgnuefi.a %{buildroot}/%{_libdir}/gnuefi/libgnuefi.a
  ln -s gnuefi/%{efi_arch}/libefi.a %{buildroot}/%{_libdir}/libefi.a
  ln -s gnuefi/%{efi_arch}/libgnuefi.a %{buildroot}/%{_libdir}/libgnuefi.a
elif [[ -d %{buildroot}/%{_prefix}/lib/gnuefi/aa64 ]] ; then
  ln -s ../../lib/gnuefi/%{efi_arch} %{buildroot}/%{_libdir}/gnuefi/%{efi_arch}
  ln -s %{efi_arch}/crt0.o %{buildroot}/%{_libdir}/gnuefi/crt0-efi-aa64.o
  ln -s %{efi_arch}/efi.lds %{buildroot}/%{_libdir}/gnuefi/elf_aa64_efi.lds
  ln -s %{efi_arch}/crt0.o %{buildroot}/%{_libdir}/gnuefi/crt0-efi-aarch64.o
  ln -s %{efi_arch}/efi.lds %{buildroot}/%{_libdir}/gnuefi/elf_aarch64_efi.lds
  ln -s %{efi_arch}/libefi.a %{buildroot}/%{_libdir}/gnuefi/libefi.a
  ln -s %{efi_arch}/libgnuefi.a %{buildroot}/%{_libdir}/gnuefi/libgnuefi.a
fi

%if %{efi_has_alt_arch}
  setarch linux32 -B make PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib INSTALLROOT=%{buildroot} ARCH=%{efi_alt_arch} install
  mkdir -p %{buildroot}%{efi_esp_dir}/%{efi_alt_arch}
  mv %{efi_alt_arch}/apps/{route80h.efi,modelist.efi} %{buildroot}%{efi_esp_dir}/%{efi_alt_arch}/

  setarch linux32 -B make PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib INSTALLROOT=%{buildroot} ARCH=%{efi_alt_arch} BFD_ARCH=%{efi_alt_arch} install_compat
  mkdir -p %{buildroot}/%{_prefix}/lib/gnuefi/
  ln -s %{efi_alt_arch}/crt0.o %{buildroot}/%{_prefix}/lib/gnuefi/crt0-efi-%{efi_alt_arch}.o
  ln -s %{efi_alt_arch}/efi.lds %{buildroot}/%{_prefix}/lib/gnuefi/elf_%{efi_alt_arch}_efi.lds
  ln -s %{efi_alt_arch}/libefi.a %{buildroot}/%{_prefix}/lib/gnuefi/libefi.a
  ln -s %{efi_alt_arch}/libgnuefi.a %{buildroot}/%{_prefix}/lib/gnuefi/libgnuefi.a
%endif

find %{buildroot}/%{_prefix}/ -type l | sed 's,%{buildroot}/\+,/,' > compat.lst

%files
%dir %{_prefix}/lib/gnuefi/
%{_prefix}/lib/gnuefi/*/
%exclude %{_prefix}/lib*/gnuefi/crt0-efi-*
%exclude %{_prefix}/lib*/gnuefi/elf_*

%files devel
%doc README.*
%{_includedir}/efi
%{_includedir}/*.mk
%{_mandir}/man3/*
%exclude %{_includedir}/efi/x86_64
%exclude %{_includedir}/efi/aarch64

%files compat -f compat.lst

%files utils
%dir %attr(0700,root,root) %{efi_esp_dir}/%{efi_arch}/
%attr(0700,root,root) %{efi_esp_dir}/%{efi_arch}/*.efi
%if %{efi_has_alt_arch}
  %dir %attr(0700,root,root) %{efi_esp_dir}/%{efi_alt_arch}/
  %attr(0700,root,root) %{efi_esp_dir}/%{efi_alt_arch}/*.efi
%endif

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.11-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.11-3
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 8 2023 Shuo Wang <abushwang@tencent.com> - 3.0.11-2
- update tar ball to 3.0.11

* Tue Jan 31 2023 Shuo Wang <abushwang@tencent.com> - 3.0.11-1
- initial build
